﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace AdventOfCode.Common
{
    public static class AOCExtensions
    {
        public static int ToInt(this string str)
        {
            try
            {
                return Convert.ToInt32(str);
            }catch (Exception e)
            {
                return 0;
                throw e;
            }

        }

        public static IEnumerable<IEnumerable<T>> Chunk<T>(this IEnumerable<T> source, int chunksize)
        {
            while (source.Any())
            {
                yield return source.Take(chunksize);
                source = source.Skip(chunksize);
            }
        }

        public static void PrintSquareArray(this int[,] arr)
        {
            for (int x = 0; x < arr.GetLength(0); x++)
            {
                for (int y = 0; y < arr.GetLength(1); y++)
                {
                    Console.Write(arr[x,y] + " ");
                }
                Console.WriteLine();
            }
        }

        public static void PrintSquareArray(this char[,] arr)
        {
            for (int x = 0; x < arr.GetLength(0); x++)
            {
                for (int y = 0; y < arr.GetLength(1); y++)
                {
                    Console.Write(arr[x, y] + " ");
                }
                Console.WriteLine();
            }
        }
    }
}
