﻿using AdventOfCode._2022.Models;
using AdventOfCode.Common;
using AdventOfCode.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace AdventOfCode._2022
{
    [AOC(year: 2022, day: 4)]
    public class Day4 : AOCDay
    {
        protected override AOCResponse ExecutePartA()
        {
            var input = GetSplitInput();
            var overlappingPairs = 0;
            foreach (var cleaningTasks in input)
            {
                var cleaningTask = new CleaningSectionTask(cleaningTasks);
                if (cleaningTask.IsOneSectionFullyOverlapped()) overlappingPairs++;
            }
            _response.Answer = overlappingPairs;
            return _response;
        }

        protected override AOCResponse ExecutePartB()
        {
            var input = GetSplitInput();
            var overlappingPairs = 0;
            foreach (var cleaningTasks in input)
            {
                var cleaningTask = new CleaningSectionTask(cleaningTasks);
                if (cleaningTask.IsAnySectionOverlapped()) overlappingPairs++;
            }
            _response.Answer = overlappingPairs;
            return _response;
        }
    }
}
