﻿using AdventOfCode._2022.Models;
using AdventOfCode.Common;
using AdventOfCode.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace AdventOfCode._2022
{
    [AOC(year: 2022, day: 5)]
    public class Day5 : AOCDay
    {
        protected override AOCResponse ExecutePartA()
        {
            var input = GetSplitInput(noTrim: true);
            var crates = input.Take(Array.FindIndex(input, x => string.IsNullOrEmpty(x)));
            var moves = input.Skip(crates.Count() + 1);
            var crateBoard = new CargoCrateBoard(_request.Version, crates.ToArray(), moves.ToArray());
            _response.Answer = string.Join("", crateBoard.GetResults()).Replace("[", string.Empty).Replace("]", string.Empty);
            return _response;
        }

        protected override AOCResponse ExecutePartB()
        {
            //Version specific is handled in CargoCrateBoard object
            return ExecutePartA();
        }
    }
}
